function configuration_reporting (instance, widget) {
    "use strict";
    var widgets = widget;

    widget.ReportingWidget = instance.Widget.extend({
        template: 'EiruReporting',
        events: {
            'click .report_action > button': 'clickOnReport',
        },
        reports: [
            {
                title: 'Resumen de ingresos',
                description: 'Permite visualizar de forma global los ingresos obtenidos por la empresa.',
                action: 'ReportResumenIngreso'
            },
            {
                title: 'Resumen de egresos',
                description: 'Permite visualizar de forma global los egresos realizado por la empresa.',
                action: 'ReportResumenEngreso'
            },
            {
                title: 'Histórico de Pagos',
                description: 'Permite visualizar de todos los pagos.',
                action: 'ReportVoucher'
            },
            {
                title: 'Histórico de Facturas',
                description: 'Permite visualizar las facturas',
                action: 'ReportInvoiceBalance'
            },
            {
                title: 'Análisis de Ventas',
                description: 'Permite realizar un analisis de las facturas de venta.',
                action: 'ReportSaleInvoiceAnalysis'
            },
            {
                title: 'Histórico de Punto de Venta',
                description: 'Permite realizar un listado de la cabecera de ventas en punto de venta.',
                action: 'ReportPos'
            },
            {
                title: 'Analisis de ventas (POS)',
                description: 'Permite visualizar de forma global los ingresos obtenidos por la empresa.',
                action: 'ReportPosOrders'
            },
            {
                title: 'Ranking Productos más Vendidos de Punto de Venta',
                description: 'Permite realizar un analisis de los Productos más Vendidos de Punto de Venta.',
                action: 'RankingPosOrdersProductcy'
            },
            {
                title: 'Ranking de Clientes (PointOfSale)',
                description: 'Permite visualizar el ranking de clientes.',
                action: 'ReportRankingPosOrdersCustomer'
            },
            {
                title: 'Análisis de Compras y Gastos',
                description: 'Permite realizar un analisis de las facturas de compra y de gastos',
                action: 'ReportPurchaseInvoiceAnalysis'
            },
            {
                title: 'Ranking Productos más Comprados',
                description: 'Permite realizar un analisis de los Productos más Comprados.',
                action: 'RankingPurchasesOrdersProductcy'
            },
            {
                title: 'Análisis de Stock',
                description: 'Permite realizar un analisis de los productos disponibles en el stock.',
                action: 'ReportStock'
            },
            {
                title: 'Análisis de Movimientos de Stock',
                description: 'Permite realizar un analisis de los productos disponibles en el stock.',
                action: 'ReportStockMove'
            },
            {
                title: 'Histórico de Llamadas CRM',
                description: 'Permite visualizar las llamadas CRM',
                action: 'ReportPhoneCall'
            },
            {
                title: 'Histórico CRM',
                description: 'Permite visualizar un histórico de CRM realizado por la empresa.',
                action: 'ReportCrm'
            },
            {
                title: 'Histórico Mensaje CRM',
                description: 'Permite visualizar un histórico de mensaje realizado por la empresa.',
                action: 'ReportMensajeCrm'
            },
            {
                title: 'Listado de Cuentas Vencidas a Cobrar',
                description: 'Permite visualizar un listado de cuentas vencidas a cobrar.',
                action: 'ReportingAccount'
            },
            {
                title: 'Listado de Cuentas a Cobrar',
                description: 'Permite visualizar un listado de cuentas a cobrar.',
                action: 'ReportingAccountPending'
            },
            {
                title: 'Informe de Trabajos',
                description: 'Permite visualizar los trabajos facturados y no facturados.',
                action: 'ReportWorks'
            },
            {
                title: 'Listado de Producción',
                description: 'Permite visualizar un listado de producción.',
                action: 'ReportMrp'
            },
            {
                title: 'Listado de Proyectos',
                description: 'Permite visualizar un listado de proyectos.',
                action: 'ReportProject'
            }

        ],
        start: function () {
        },

        clickOnReport: function (e) {
            var templateName = this.$el.find(e.target).val();
            this.renderReport(templateName);
        },

        renderReport: function (templateName) {
            var Widget = this.getWidgetFromTemplate(templateName);
            var WidgetInstance = new Widget(this);
            var container = this.$el.find('.oe_form_sheet.oe_form_sheet_width');
            container.find('.report_view').hide({
                effect: 'fade',
                duration: 200,
                complete: function () {
                    WidgetInstance.appendTo(container);
                }
            });
        },

        getWidgetFromTemplate: function (templateName) {
            var widgetName = `${templateName}Widget`;
            return _.pick(widget, widgetName)[widgetName];
        },
    });
}
